#include <iostream>
#include <vector>


#include <opencv2/opencv.hpp>

// using namespace std; do not use this in the real life

class location {
public:
    int x;
    int y;
    location(int ix, int iy){
        x=ix; y=iy;
    }
    virtual void move(int dx, int dy){x+=dx; y+=dy;};
};

class point: public location {
public:
    cv::Scalar color = {255,255,255};
    int thicness=1;

    point(int ix, int iy):location(ix,iy){};

    virtual void draw(cv::Mat& image){
        cv::line(image,cv::Point(x,y), cv::Point(x,y), color, thicness,  cv::LINE_8 );
    }
};

class line : public point {
public:
    point& a = *this;
    point b={0,0};
    int linetype = cv::LINE_8;

    line(point ia, const point ib):point(ia.x, ia.y){
        b=ib;
    };

    virtual void move(int dx, int dy){
        a.move(dx,dy);
        b.move(dx,dy);
    };

    virtual void draw(cv::Mat& image){
         cv::line(image,cv::Point(a.x,a.y), cv::Point(b.x, b.y), color, thicness,  cv::LINE_8 );
    };
};

class rectangle: public line {
public:
    rectangle(point ia, const point ib):line(ia,ib){};

    virtual void draw(cv::Mat& image){
      cv::rectangle(image,cv::Point(a.x,a.y), cv::Point(b.x, b.y), color, thicness,  cv::LINE_8 );
    };
};

class shape: public point {
public:
    //virtual method calls work with pointers, but does not work with allocated classes
    //so we have vectot of pointers
    std::vector<point*> primitives;

    shape():point(0,0){};

    virtual void move(int dx, int dy){
        std::for_each(primitives.begin(),primitives.end(), [&](auto&& l){l->move(dx,dy);});
    };

    virtual void draw(cv::Mat& image){
        // for(auto& p: primitives){
        //     p->draw(image);
        // }
        std::for_each(primitives.begin(),primitives.end(), [&](auto&& l){l->draw(image);});
    };

    void insert(point* pp){
        primitives.emplace_back(pp);
    }
};

class canvas : public shape{
public:
    void draw(){
        cv::Mat image = cv::Mat::zeros( 500, 500, CV_8UC3 );
        shape::draw(image);
        cv::imshow("Output", image);
    }
};

int main() {

    std::cout << "Hello World!" << std::endl;
    canvas the_canvas;
    the_canvas.insert( new line(point(0,0),point(100,100)));
    the_canvas.insert( new rectangle(point(100,100),point(300,300)));
    the_canvas.draw();

    cv::waitKey();
    std::cout << "Bye-bye World!" << std::endl;
    return 0;
}
