#include <iostream>
#include <memory>

class MyClass {
public:
    explicit MyClass(std::string name): mName(name) {}

    ~MyClass() {
        std::cout << "I'm dying…" << std::endl;
    }

    void saySomething() {
        std::cout << "Hello! I am " << mName << "!" << std::endl;
    }



private:
    std::string mName;
};

void foo1(std::unique_ptr<MyClass> bar) {
    bar->saySomething();
}

void foo2(std::shared_ptr<MyClass> bar) {
    bar->saySomething();
}


int main(){

// raw pointer
    auto* myClass = new MyClass("Raw");
    myClass->saySomething();
    delete myClass;
// unique_ptr
    auto uPtr = std::make_unique<MyClass>("Unique");
    //auto smartPtr2 = smartPtr;  // ERROR!
    //foo1(smartPtr); // ERROR!
    std::cout<<"----" << uPtr.get() << std::endl;
    foo1(std::move(uPtr));
    std::cout<<"----" << uPtr.get() << std::endl;
// shared_ptr
    auto sPtr = std::make_shared<MyClass>("Shared");
    foo2(sPtr);
    std::cout<<"----" << sPtr.get() << std::endl;
    return 0;

}
